
Object subclass: #ConfigurationOfISO3166
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfISO3166'!

!ConfigurationOfISO3166 commentStamp: 'HernanMoralesDurand 7/29/2015 21:15' prior: 0!
See catalog method category for documentation.
!

!ConfigurationOfISO3166 class methodsFor: 'development support' stamp: 'HernanMoralesDurand 6/26/2015 03:25'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfISO3166 class methodsFor: 'private' stamp: 'HernanMoralesDurand 6/26/2015 03:25'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfISO3166 class methodsFor: 'private' stamp: 'HernanMoralesDurand 6/26/2015 03:25'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfISO3166 class methodsFor: 'private' stamp: 'HernanMoralesDurand 6/26/2015 03:25'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfISO3166 class methodsFor: 'metacello tool support' stamp: 'HernanMoralesDurand 6/26/2015 03:25'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfISO3166 class methodsFor: 'loading' stamp: 'HernanMoralesDurand 6/26/2015 03:25'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfISO3166 class methodsFor: 'loading' stamp: 'HernanMoralesDurand 6/26/2015 03:25'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfISO3166 class methodsFor: 'loading' stamp: 'HernanMoralesDurand 6/26/2015 03:25'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfISO3166 class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 6/26/2015 03:25'!
project

	^self new project! !

!ConfigurationOfISO3166 class methodsFor: 'development support' stamp: 'HernanMoralesDurand 6/26/2015 03:25'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfISO3166 methodsFor: 'baselines' stamp: 'HernanMoralesDurand 7/29/2015 22:17'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/hernan/ISO3166/main/'.
		spec project: 'NeoCSV' with: [
				spec
					className: #ConfigurationOfNeoCSV;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo40/main/' ].
		spec package: #ISO3166. ].
! !

!ConfigurationOfISO3166 methodsFor: 'catalog' stamp: 'HernanMoralesDurand 7/29/2015 22:15'!
catalogChangeLog
	"Returns a paragraph describing the most important changes in the configuration class."
	^ '- 1.0 - 08/29/2015
[[[
	ConfigurationOfISO3166 project version: ''1.0'' ) load					
]]]
First version published
'! !

!ConfigurationOfISO3166 methodsFor: 'catalog' stamp: 'HernanMoralesDurand 7/29/2015 21:15'!
catalogContactInfo
	"Returns a paragraph describing contact information such as email, mailing lists and website."

	^ 'Written and maintained by Hernán Morales Durand. Discussions on the Pharo mailing lists.'! !

!ConfigurationOfISO3166 methodsFor: 'catalog' stamp: 'HernanMoralesDurand 7/29/2015 21:48'!
catalogDescription
	"Returns a paragraph describing the project"
	^ 'This package ISO 3166-1 provides a wrapper to fetch and access ISO 3166 Part 1 data.'! !

!ConfigurationOfISO3166 methodsFor: 'catalog' stamp: 'HernanMoralesDurand 7/29/2015 22:14'!
catalogKeyClassesAndExample
	"Returns a paragraph or more describing the key classes of your project. You can use Pillar/Pier syntax to layout out the text i.e., ==Code== and - for bullet."
	^ 'To get a sorted Collection with all ISO-3166 codes:
==ISO3166P1 sortedIso3166Codes==

To obtain all the countries with official assigned codes:
==ISO3166P1 sortedIso3166AssignedCodes==

Get an ISO3166P1Code object using any 2-letter or 3-letter code:
==ISO3166P1 atLetterCode: ''FR''.==

Obtain the ISO 3166 code number for Zimbabwe:
==ISO3166P1 codeNumberFrom2LetterCode: ''ZW''. "716"==

Obtain the three-letter country code of Niger:
==(ISO3166P1 atCountryName: ''Niger'') codeThreeLetter. " ''NER''==

Obtain the country code top-level domain of Denmark:
==(ISO3166P1 atCountryName: ''Denmark'') ccTLD. " ''.dk'' "==

Populate (or re-initialize) the ISO-3166 codes from remote data source:
==ISO3166P1 initialize==
'! !

!ConfigurationOfISO3166 methodsFor: 'catalog' stamp: 'HernanMoralesDurand 7/29/2015 21:16'!
catalogKeywords
	"Returns an array of symbols"
	^ #(country ISO ISO3166 codes) ! !

!ConfigurationOfISO3166 methodsFor: 'accessing' stamp: 'HernanMoralesDurand 6/26/2015 03:25'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfISO3166 methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 6/26/2015 03:25'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfISO3166 methodsFor: 'accessing' stamp: 'HernanMoralesDurand 6/26/2015 03:25'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfISO3166 methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 8/2/2015 00:09'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.2'.
! !

!ConfigurationOfISO3166 methodsFor: 'versions' stamp: 'HernanMoralesDurand 7/29/2015 22:17'!
version10: spec
	<version: '1.0' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.0'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '7/29/2015 22:17'.
		spec project: 'NeoCSV' with: '12'.
		spec package: #ISO3166 with: 'ISO3166-HernanMoralesDurand.7'. ].
! !

!ConfigurationOfISO3166 methodsFor: 'versions' stamp: 'HernanMoralesDurand 7/31/2015 12:17'!
version11: spec
	<version: '1.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.1'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '7/31/2015 12:17'.
		spec project: 'NeoCSV' with: '12'.
		spec package: #ISO3166 with: 'ISO3166-HernanMoralesDurand.8'. ].
! !

!ConfigurationOfISO3166 methodsFor: 'versions' stamp: 'HernanMoralesDurand 8/2/2015 00:09'!
version12: spec
	<version: '1.2' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.2'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '8/2/2015 00:09'.
		spec project: 'NeoCSV' with: '12'.
		spec package: #ISO3166 with: 'ISO3166-HernanMoralesDurand.9'. ].
! !
